/*******************************************************************************
  File : debug.h

  Description : Fichier en-tte pour le module de dbogage.
*******************************************************************************/

#ifndef DEBUG_H
#define DEBUG_H

/*******************************************************************************
  Include files :
*******************************************************************************/

#include "data.h"

/*******************************************************************************
  Types :
*******************************************************************************/

typedef struct {

  void (*close_debug_files) (void);
  void (*dump) (void);
  void (*new_debug_files) (void);
  void (*open_debug_files) (void);
  int (*print) (const char *format, ...);
  void (*print_informations) (void);
  void (*print_statistics) (void);
  void (*test_hash) (void);
  void (*trace) (char fn_name[], bool fn_print, int *fn_calls);

} debug_module_s;

/*******************************************************************************
  Data :
*******************************************************************************/

extern debug_module_s debug;

#ifdef DEBUG
extern int debug_nodes;
#endif /* DEBUG */

#endif /* DEBUG_H */
