/*******************************************************************************
  File : hash.h

  Description : Fichier en-tte pour le module de hachage.
*******************************************************************************/

#ifndef HASH_H
#define HASH_H

/*******************************************************************************
  Include files :
*******************************************************************************/

#include "data.h"

/*******************************************************************************
  Types :
*******************************************************************************/

/* Un nombre entier non sign caractrise les lments qui entrent dans
   l'algorithme de hachage : */
typedef unsigned int h_value_s;

/* Fonctions du module de hachage : */
typedef struct {

  h_value_s (*compute_h_position) (void);
  void (*init_h_values) (void);

} hash_module;

/*******************************************************************************
  Data :
*******************************************************************************/

extern hash_module hash;

#ifdef DEBUG
extern int compute_h_position_calls;
extern int init_h_values_calls;
#endif /* DEBUG */

extern h_value_s h_position;
extern h_value_s h_position_history[MOVES_LIMIT * 2];

extern h_value_s h_values[2][17][9][9];
extern h_value_s h_values_color[2];
extern h_value_s h_values_ep[9][9];
extern h_value_s h_values_castle[5][2];

#endif /* HASH_H */
