/*******************************************************************************
  File : moves.h

  Description : Fichier en-tte pour le module "moves".
*******************************************************************************/

#ifndef MOVES_H
#define MOVES_H

/*******************************************************************************
  Include files :
*******************************************************************************/

#include "data.h"

/*******************************************************************************
  Types :
*******************************************************************************/

typedef struct {

  int (*generate) (move_s *legal_moves, int search_type);
  bool (*is_attacked) (int x0, int y0, int color);
  void (*make) (move_s move);
  void (*unmake) (move_s move);

} moves_module_s;

/*******************************************************************************
  Data :
*******************************************************************************/

extern moves_module_s moves;

#ifdef DEBUG
extern int generate_calls;
extern int is_attacked_calls;
extern int make_calls;
extern int search_auth_dir_calls;
extern int unmake_calls;
#endif /* DEBUG */

#endif /* MOVES_H */
