/*******************************************************************************
  File : tools.h

  Description : Fichier en-tte pour le module "tools".
*******************************************************************************/

#ifndef TOOLS_H
#define TOOLS_H

/*******************************************************************************
  Include files :
*******************************************************************************/

#include "data.h"

/*******************************************************************************
  Types :
*******************************************************************************/

typedef struct {

  void (*compute_time) (void);
  bool (*convert_lan_move) (const char *lan_move, move_s *move);
  void (*convert_move) (move_s move, char lan_move[]);
  unsigned int (*generate_random) (void);
  bool (*is_repeated) (void);
  void (*print_board) (FILE *output_file);
  void (*read_input) (char string[]);
  int (*send_output) (bool to_stdout, const char *format, ...);
  void (*update_pieces) (void);
  bool (*verify_move) (char lan_move[]);

} tools_module_s;

/*******************************************************************************
  Data :
*******************************************************************************/

extern tools_module_s tools;

#ifdef DEBUG
extern int compute_time_calls;
extern int convert_lan_move_calls;
extern int convert_move_calls;
extern int generate_random_calls;
extern int is_repeated_calls;
extern int print_board_calls;
extern int read_input_calls;
extern int update_pieces_calls;
extern int send_output_calls;
extern int verify_move_calls;
#endif /* DEBUG */

#endif /* TOOLS_H */
