/*******************************************************************************
  File : uci.h

  Description : Fichier en-tte pour le module "uci".
*******************************************************************************/

#ifndef UCI_H
#define UCI_H

/*******************************************************************************
  Types :
*******************************************************************************/

typedef struct {

  void (*debug_cmd) (void);
  void (*go) (char string[]);
  void (*info) (int score);
  void (*isready) (void);
  void (*ponderhit) (void);
  void (*position) (char string[]);
  void (*quit) (int status);
  void (*registration) (void);
  void (*setoption) (void);
  void (*stop) (void);
  void (*uci_cmd) (void);
  void (*ucinewgame) (void);

} uci_module_s;

/*******************************************************************************
  Data :
*******************************************************************************/

extern uci_module_s uci;

#ifdef DEBUG
extern int go_calls;
extern int info_calls;
extern int isready_calls;
extern int position_calls;
extern int quit_calls;
extern int uci_cmd_calls;
extern int ucinewgame_calls;
#endif /* DEBUG */

extern int uci_binc;
extern int uci_btime;
extern int uci_movetime;
extern int uci_winc;
extern int uci_wtime;

#endif /* UCI_H */
